package dkolev.html;

import java.util.*;
import java.io.*;
import java.net.*;

public class SourceDownloader {

	private Vector<String> _cookies = new Vector<String>();

	public String getSource(String url, boolean download) throws Exception {

		StringBuilder sb = new StringBuilder();

		try {

			URL u = new URL(url);
			HttpURLConnection uc = (HttpURLConnection) u.openConnection();
			uc.setInstanceFollowRedirects(true);

			if (_cookies.size() > 0) {
				for (String cookie : _cookies) {
					uc.setRequestProperty("Cookie", cookie);
				}

				_cookies.clear();
			}

			for (int j = 1;; j++) {
				String key = uc.getHeaderFieldKey(j);
				String value = uc.getHeaderField(j);

				if (value == null || key == null) {
					break;
				}

				if (!_cookies.contains(value)
						&& key.toLowerCase().trim().equals("set-cookie") &&
						// avoid the kiss of death
						!value.trim().contains("nonSSOLogin")) {
					_cookies.add(value);

				}
			}
			
			//do we care for the actual content? if not, don't read it
			if (download) {
				InputStream in = new BufferedInputStream(uc.getInputStream());
				Reader r = new InputStreamReader(in);
				int c;
				while ((c = r.read()) != -1) {
					sb.append((char) c);
				}
			}
		} catch (MalformedURLException ex) {
			throw new Exception(url + " is not a valid URL.", ex);
		} catch (FileNotFoundException ex) {
			throw new Exception("File was reported missing", ex);
		} catch (IOException ex) {
			throw new Exception("Cannot read source", ex);
		} finally {

		}

		return sb.toString();
	}
}
